﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using StudentManagementSystem.Persistence.DatabaseContext;

#nullable disable

namespace StudentManagementSystem.Persistence.Migrations
{
    [DbContext(typeof(StudentsDbContext))]
    [Migration("20240525124200_v01.AddAddressesAndPersons")]
    partial class v01AddAddressesAndPersons
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "8.0.5")
                .HasAnnotation("Relational:MaxIdentifierLength", 128);

            SqlServerModelBuilderExtensions.UseIdentityColumns(modelBuilder);

            modelBuilder.Entity("StudentManagementSystem.Domain.Entities.Address", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<string>("City")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("nvarchar(100)");

                    b.Property<string>("Country")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("nvarchar(100)");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime2");

                    b.Property<string>("PostalCode")
                        .IsRequired()
                        .HasMaxLength(20)
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("State")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("nvarchar(100)");

                    b.Property<string>("Street")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("nvarchar(100)");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime2");

                    b.HasKey("Id");

                    b.ToTable("Addresses", (string)null);

                    b.HasData(
                        new
                        {
                            Id = 1,
                            City = "Anytown",
                            Country = "USA",
                            CreatedAt = new DateTime(2024, 5, 25, 12, 42, 0, 72, DateTimeKind.Utc).AddTicks(8327),
                            PostalCode = "12345",
                            State = "Anystate",
                            Street = "123 Main St",
                            UpdatedAt = new DateTime(2024, 5, 25, 12, 42, 0, 72, DateTimeKind.Utc).AddTicks(8328)
                        },
                        new
                        {
                            Id = 2,
                            City = "Othertown",
                            Country = "USA",
                            CreatedAt = new DateTime(2024, 5, 25, 12, 42, 0, 72, DateTimeKind.Utc).AddTicks(8329),
                            PostalCode = "67890",
                            State = "Otherstate",
                            Street = "456 Elm St",
                            UpdatedAt = new DateTime(2024, 5, 25, 12, 42, 0, 72, DateTimeKind.Utc).AddTicks(8330)
                        });
                });

            modelBuilder.Entity("StudentManagementSystem.Domain.Entities.Person", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<int?>("AddressId")
                        .HasColumnType("int");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime2");

                    b.Property<DateTime>("DateOfBirth")
                        .HasColumnType("datetime2");

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("nvarchar(100)");

                    b.Property<string>("FamilyName")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("nvarchar(100)");

                    b.Property<string>("PersonName")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("nvarchar(100)");

                    b.Property<DateTime>("UpdatedAt")
                        .HasColumnType("datetime2");

                    b.HasKey("Id");

                    b.HasIndex("AddressId")
                        .IsUnique()
                        .HasFilter("[AddressId] IS NOT NULL");

                    b.ToTable("Persons", (string)null);

                    b.HasData(
                        new
                        {
                            Id = 1,
                            AddressId = 1,
                            CreatedAt = new DateTime(2024, 5, 25, 12, 42, 0, 73, DateTimeKind.Utc).AddTicks(946),
                            DateOfBirth = new DateTime(1990, 1, 1, 0, 0, 0, 0, DateTimeKind.Utc),
                            Email = "john.doe@example.com",
                            FamilyName = "Doe",
                            PersonName = "John",
                            UpdatedAt = new DateTime(2024, 5, 25, 12, 42, 0, 73, DateTimeKind.Utc).AddTicks(946)
                        },
                        new
                        {
                            Id = 2,
                            AddressId = 2,
                            CreatedAt = new DateTime(2024, 5, 25, 12, 42, 0, 73, DateTimeKind.Utc).AddTicks(948),
                            DateOfBirth = new DateTime(1985, 5, 15, 0, 0, 0, 0, DateTimeKind.Utc),
                            Email = "jane.smith@example.com",
                            FamilyName = "Smith",
                            PersonName = "Jane",
                            UpdatedAt = new DateTime(2024, 5, 25, 12, 42, 0, 73, DateTimeKind.Utc).AddTicks(948)
                        });
                });

            modelBuilder.Entity("StudentManagementSystem.Domain.Entities.Person", b =>
                {
                    b.HasOne("StudentManagementSystem.Domain.Entities.Address", "Address")
                        .WithOne("Person")
                        .HasForeignKey("StudentManagementSystem.Domain.Entities.Person", "AddressId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.Navigation("Address");
                });

            modelBuilder.Entity("StudentManagementSystem.Domain.Entities.Address", b =>
                {
                    b.Navigation("Person")
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
